#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
"Code for getting a PIN and validating it."
_rev = "$Revision: 46 $"[10:-1].strip()
__version__ = "1.0."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ = "$Date: 2008-05-02 17:36:23 +0100 (Fri, 02 May 2008) $"[6:18].strip()

#SIM PIN dialog

import pygtk
pygtk.require('2.0')
import gtk

def ErrorDialog(parent, title,msg):
    "display an error"
    msgbox = gtk.MessageDialog(parent, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL,
                                type= gtk.MESSAGE_ERROR, message_format = msg)
    msgbox.set_title(title)
    msgbox.run()
    msgbox.destroy()


def PINdialog(window,title_text="PIN Code",prompt_text = "Enter:"):
    "Display a PIN dialog"
    dialog = gtk.Dialog(title=title_text, parent = window,
                        flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                        buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))

    entry = gtk.Entry()
    entry.set_max_length(4)
    entry.set_width_chars(4)
    entry.set_visibility(False)
    entry.set_invisible_char('*')
    entry.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))
    Hbox = gtk.HBox(False, 5)
    Hbox.pack_start(gtk.Label(prompt_text))
    Hbox.pack_start(entry)
    dialog.vbox.add(Hbox)
    dialog.show_all()
    response = dialog.run()
    dialog.hide()
    if response == gtk.RESPONSE_ACCEPT:
        return entry.get_text()
    else:
        return ''

def runPIN(window,title_text,prompt_text, strings):
    "Display dilaog and get return results"
    pin = ''
    while True:
        pin = PINdialog(window,title_text,prompt_text)
        valid = True
        if pin == '' : return '' #User cancelled
        if len(pin) != 4: 
            ErrorDialog(window, strings['error'],strings['error_pin_length'])
            continue
        else:
            for n in pin:
                if n not in "1234567890":
                    valid = False
                    ErrorDialog(window, strings['error'],strings['error_pin_nonnumber'])
                    #non number detected
                    break
            if valid: break
    return pin
    
